FROM docker.io/openshift/jenkins-slave-base-centos7:v3.11

ENV BASH_ENV=/usr/local/bin/scl_enable \
    ENV=/usr/local/bin/scl_enable \
    NODEJS_VERSION=12 \
    NPM_CONFIG_PREFIX=$HOME/.npm-global \
    PATH=$HOME/node_modules/.bin/:$HOME/.npm-global/bin/:$PATH \
    PHP_VERSION=7.4 \
    PROMPT_COMMAND=". /usr/local/bin/scl_enable" \
    SONAR_RUNNER_HOME=/opt/sonar-runner \
    SONAR_RUNNER_VERSION=2.4 \
    YARN_VERSION=1.22.19

LABEL com.redhat.component="jenkins-agent-sonar${SONAR_RUNNER_VERSION}-centos7-container" \
      io.k8s.description="The jenkins agent sonar image ships with nodejs/php runtimes on top of the jenkins slave base image." \
      io.k8s.display-name="Jenkins Agent - Node.js ${NODEJS_VERSION}, PHP ${PHP_VERSION}, Sonar scanner ${SONAR_RUNNER_VERSION}" \
      io.openshift.tags="openshift,jenkins,agent,nodejs${NODEJS_VERSION},php${PHP_VERSION},sonar${SONAR_RUNNER_VERSION},nodejs,php,sonar" \
      architecture="x86_64" \
      name="ci/jenkins-slave-sonar${SONAR_RUNNER_VERSION}" \
      maintainer="Samuel MARTIN MORO <faust64@gmail.com>" \
      help="For more information visit https://gitlab.com/synacksynack/opsperator/docker-jenkins-agent-sonar" \
      version="1.0.2"

COPY config/* /usr/local/bin/

# Install NodeJS & PHP
RUN rm -f /usr/local/bin/el8.repo \
    && if test "$DO_UPGRADE"; then \
	yum -y upgrade; \
    fi \
    && yum install -y centos-release-scl-rh \
    && yum install -y https://dl.fedoraproject.org/pub/epel/epel-release-latest-7.noarch.rpm \
    && yum install -y https://rpms.remirepo.net/enterprise/remi-release-7.rpm \
    && yum install -y --setopt=tsflags=nodocs git wget curl unzip openssh \
	mercurial make gcc-c++ subversion ca-certificates procps-ng bash \
	openssl-devel nss_wrapper \
    && curl -sL https://rpm.nodesource.com/setup_$NODEJS_VERSION.x | bash - \
    && yum -y install nodejs \
    && yum install -y \
	--enablerepo=remi-php`echo $PHP_VERSION | sed 's|^\([1-9]*\)\.\([0-9]*\).*|\1\2|'` \
	php php-cli \
    && wget -O /usr/src/yarn.tar.gz \
	https://github.com/yarnpkg/yarn/releases/download/v$YARN_VERSION/yarn-v$YARN_VERSION.tar.gz \
    && tar -C /opt -xzf /usr/src/yarn.tar.gz \
    && rm -f /usr/src/yarn.tar.gz \
    && yum clean all -y \
    && rm -fr /var/cache/yum

ENV PATH=/opt/yarn-v${YARN_VERSION}/bin:$PATH

# Setup NodeJS modules - Fix Java
RUN if test "$HTTP_PROXY"; then \
	( \
	    echo registry=http://registry.npmjs.org/ \
	    && echo http-proxy=$HTTP_PROXY \
	    && echo proxy=$HTTP_PROXY \
	    && echo strict-ssl=false \
	) >$HOME/.npmrc; \
    fi \
    && npm install -g node-gyp pm2 mocha sonar-runner expect \
    && for bin in java jre keytool servertool; \
       do \
           test -x /usr/bin/$bin -o -h /usr/bin/$bin && continue; \
           find /usr/lib/jvm -name $bin | grep $(uname -m) | sort | tail -1 \
	       | while read source; \
	       do \
		   ln -sf $source /usr/bin/$bin; \
	       done; \
       done \
    && rm -f $HOME/.npmrc \
    && if test -s /run/secrets/kubernetes.io/serviceaccount/service-ca.crt; then \
	chmod 0666 /etc/pki/ca-trust/extracted/java/cacerts \
	&& keytool -importcert -alias Root_CA -keystore /etc/pki/ca-trust/extracted/java/cacerts -file /run/secrets/kubernetes.io/serviceaccount/service-ca.crt -storepass changeit --noprompt \
	&& chmod 0444 /etc/pki/ca-trust/extracted/java/cacerts \
	&& cat /run/secrets/kubernetes.io/serviceaccount/service-ca.crt >/etc/pki/ca-trust/source/anchors/k8s-ca.pem \
	&& chmod 0644 /etc/pki/ca-trust/source/anchors/k8s-ca.pem \
	&& update-ca-trust; \
    fi

# Install Sonar Runner
RUN mkdir -p /opt \
    && wget https://repo1.maven.org/maven2/org/codehaus/sonar/runner/sonar-runner-dist/${SONAR_RUNNER_VERSION}/sonar-runner-dist-${SONAR_RUNNER_VERSION}.zip \
    && unzip sonar-runner-dist-${SONAR_RUNNER_VERSION}.zip \
    && mv sonar-runner-${SONAR_RUNNER_VERSION} /opt/sonar-runner \
    && rm -rf sonar-runner-dist-${SONAR_RUNNER_VERSION}.zip /opt/sonar-runner/conf/sonar-runner.properties \
    && chown -R 1001:0 $HOME $SONAR_RUNNER_HOME \
    && chmod -R g+rw $HOME $SONAR_RUNNER_HOME
ENV PATH $SONAR_RUNNER_HOME/bin:$PATH

USER 1001
